//+------------------------------------------------------------------+
//|                                        TickPriceChannel_v2.1.mq4 |
//|                                Copyright  2009, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Lime
#property indicator_color2 Black
#property indicator_color3 Tomato
#property indicator_color4 Aqua
#property indicator_width3 2
#property indicator_width4 2
#property indicator_color5 DodgerBlue
#property indicator_color6 DodgerBlue
#property indicator_color7 DodgerBlue
#property indicator_style7 2
//---- buffers
extern int     Length      =    14; //Length(Period) of Channel
extern int     NumTicks    =     0; //TimeFrame in ticks
extern int     NumSecs     =    10; //TimeFrame in secs
extern int     MaxBars     =    50; //Max Number of bars   

double Hi[];
double Lo[];
double Up[];
double Dn[];
double Mid[];
double tOpen[];
double tClose[];

int      tickCounter=0, barCounter, pSecs;
datetime pTime;
string   short_name, t;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0, Hi);
   SetIndexStyle(1,DRAW_HISTOGRAM,CLR_NONE);
   SetIndexBuffer(1, Lo);
      if(NumTicks == 1)
      {
      SetIndexStyle(3,DRAW_LINE,0,1);
      }
      else
      {
      SetIndexStyle(2,DRAW_ARROW);
      SetIndexBuffer(2, tOpen);
      SetIndexArrow(2,158); 
      SetIndexStyle(3,DRAW_ARROW);
      SetIndexArrow(3,158); 
      }
   SetIndexBuffer(3, tClose);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4, Up);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5, Dn);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6, Mid);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(NumTicks > 0) t = NumTicks +" Ticks] ";
   if(NumSecs  > 0) t = NumSecs  +" Secs] ";
   short_name="TickPriceChannel_v2.1 ["+t+"("+Length+","+MaxBars+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Hi");
   SetIndexLabel(1,"Lo");
   SetIndexLabel(2,"Open");
   SetIndexLabel(3,"Close");
   SetIndexLabel(4,"Upper");
   SetIndexLabel(5,"Lower");
   SetIndexLabel(6,"Middle");
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
   SetIndexEmptyValue(6,0.0);
      
   pTime = Time[0];
   pSecs = TimeCurrent(); 
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
//----
   return(0);
}

void ShiftArray(int mode)
{
   if(mode==0)
   {
      for(int cnt=barCounter; cnt >= 0; cnt--)
      {
      Hi [cnt] = Hi[cnt-1];
      Lo [cnt] = Lo[cnt-1];
      tOpen[cnt] = tOpen[cnt-1];
      tClose[cnt] = tClose[cnt-1];
      Up [cnt] = Up[cnt-1];
      Dn [cnt] = Dn[cnt-1];
      Mid[cnt] = Mid[cnt-1];
      }
   }
   else
   {
      for(cnt=1; cnt <= barCounter; cnt++)
      {
      Hi [cnt-1] = Hi[cnt];
      Lo [cnt-1] = Lo[cnt];
      tOpen[cnt-1] = tOpen[cnt];
      tClose[cnt-1] = tClose[cnt];
      Up [cnt-1] = Up[cnt];
      Dn [cnt-1] = Dn[cnt];
      Mid[cnt-1] = Mid[cnt];
     
      Hi[cnt]=0.0;
      Lo[cnt]=0.0;
      tOpen[cnt]=0.0;
      tClose[cnt]=0.0;
      Up[cnt]=0.0;
      Dn[cnt]=0.0;
      Mid[cnt]=0.0;
      }
   }
}

bool isNewBar()
{
   bool res=false;
   if (Time[0]!=pTime)
   {
   res=true;
   pTime=Time[0];
   }   

   return(res);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,cnt_bars = IndicatorCounted();
   
   if(cnt_bars < 1) //tickCounter == 0)
   {
      for(i=Bars-1;i>=0;i--)
      {
      Hi[i]=0.0;
      Lo[i]=0.0;
      tOpen[i]=0.0;
      tClose[i]=0.0;
      Up[i]=0.0;
      Dn[i]=0.0;
      Mid[i]=0.0;
      }
   }
   
   tickCounter++;
   
   bool tcond = false;   
   if(NumTicks > 0 && NumSecs == 0) tcond = tickCounter > 0 && tickCounter % NumTicks == 0;
   if(NumTicks == 0 && NumSecs > 0) tcond = TimeCurrent() >= pSecs + NumSecs;
   
   if(tcond) 
   {
   barCounter ++; 
   if(!isNewBar()) ShiftArray(0);
   tOpen[0]=Bid;
   tClose[0]=Bid;
   Hi[0]=Bid;
   Lo[0]=Bid; 
   if(NumSecs > 0) pSecs = TimeCurrent();
   }
   
   if(barCounter > 0)
   {
   if(isNewBar()) ShiftArray(1);
   tClose[0]=Bid;
   Hi[0]=MathMax(Hi[0],Bid);
   if(Lo[0] > 0) Lo[0]=MathMin(Lo[0],Bid); else Lo[0]=Bid; 
   }
   
   
   if(barCounter >= MaxBars) 
   {
      for(i=MaxBars; i < MaxBars+1;i++)
      { 
      Hi[i]=0.0;
      Lo[i]=0.0;
      tOpen[i]=0.0;
      tClose[i]=0.0;
      Up[i]=0.0;
      Dn[i]=0.0;
      Mid[i]=0.0;
      }
   }
     
   if(barCounter > Length)
   {
   Up[0] = TickHighest(Length); 
   Dn[0] = TickLowest(Length); 
   Mid[0]= 0.5*(Up[0] + Dn[0]);
   }
    
//----
   return(0);
}
//+------------------------------------------------------------------+
double TickLowest(int per)
{
   double lowest = 1000000;
   for(int i = 0;i < per;i++) lowest = MathMin(lowest,Lo[i]);
   return(lowest);
}                

double TickHighest(int per)
{
   double highest = 0;
   for(int i = 0;i < per;i++) highest = MathMax(highest,Hi[i]);
   return(highest);
}                

